"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseAction_1 = require("./BaseAction");
var store_1 = require("../utils/store");
var NormalAction = /** @class */ (function (_super) {
    tslib_1.__extends(NormalAction, _super);
    function NormalAction(action, instanceName) {
        var _this = _super.call(this, instanceName) || this;
        _this.effect = undefined;
        // @ts-ignore
        return _this.proxy(function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var normal = action.apply(void 0, tslib_1.__spread(args));
            normal.type = _this.successType;
            if (_this.effect) {
                normal.effect = _this.effect;
            }
            return store_1.getStore().dispatch(normal);
        }, ['onSuccess', 'changeEffect'], []);
    }
    NormalAction.prototype.changeEffect = function (effect) {
        this.effect = effect;
    };
    NormalAction.prototype.onSuccess = function (effect) {
        return {
            when: this.successType,
            effect: effect,
        };
    };
    return NormalAction;
}(BaseAction_1.BaseAction));
exports.NormalAction = NormalAction;
